
#include <stdlib.h>
#include <string.h>

#include "config.h"


struct lt_thread *lt_thread_add(struct lt_config_app *cfg, int fd, pid_t pid)
{
	struct lt_thread *t;

	if (NULL == (t = (struct lt_thread*) malloc(sizeof(struct lt_thread)))) {
		perror("malloc failed");
		return NULL;
	}

	memset(t, 0x0, sizeof(*t));

	if (-1 == lt_stats_alloc(cfg, t)) {
		free(t);
		return NULL;
	}

	t->fifo_fd = fd;
	t->tid = pid;
	gettimeofday(&t->tv_start, NULL);

	t->next = cfg->threads;
	cfg->threads = t;
	return t;
}

struct lt_thread *lt_thread_first(struct lt_config_app *cfg)
{
	return cfg->iter = cfg->threads;
}

struct lt_thread *lt_thread_next(struct lt_config_app *cfg)
{
	return cfg->iter = (cfg->iter ? cfg->iter->next : NULL); 
}
